<template>
  <div>
    <CustomSubHeader>
      <CBreadcrumb class="border-0 mb-0">{{ title }}</CBreadcrumb>
      <el-tag v-if="dCategory._creator && dCategory._creator.first_name" type="primary">
        <span>ایجاد یا اصلاح کننده: </span>
        <span> {{ dCategory._creator.first_name + ' ' + dCategory._creator.last_name }} </span>
      </el-tag>
      <CButton size="sm" color="primary" class="mr-auto" :to="{ name: 'admin-download-categories' }"
        >برگشت به صفحه قبل</CButton
      >
      <CButton size="sm" color="success" style="margin-right: 10px" @click="upload">بروزرسانی</CButton>
    </CustomSubHeader>
    <CRow>
      <CCol xl="6">
        <CCard>
          <CCardBody>
            <CForm>
              <CInput
                v-model="dCategory.name"
                label="نام"
                horizontal
                :description="validation.name ? validation.name.msg : null"
                :class="validation.name ? 'err' : null"
              />
            </CForm>
          </CCardBody>
        </CCard>
      </CCol>
    </CRow>
  </div>
</template>

<script>
export default {
  name: 'AddminDownloadCategoryDetails',
  layout: 'admin',
  async asyncData({ $axios, params, error }) {
    try {
      const dCategory = await $axios.get(`/api/public/dCategory/${params.item}`)
      return {
        dCategory: dCategory.data
      }
    } catch (e) {
      error({ status: 404, message: 'Page not found' })
    }
  },
  data() {
    return {
      title: 'ویرایش دسته بندی',
      dCategory: null,
      validation: {}
    }
  },
  head() {
    return {
      title: this.title
    }
  },
  methods: {
    upload() {
      this.validation = {}

      this.$axios
        .put(`/api/admin/dCategory/${this.dCategory._id}`, this.dCategory)
        .then(response => {
          if (response.data) {
            this.$message({
              message: 'آیتم با موفقیت بروزرسانی شد.',
              type: 'success'
            })
          }
        })
        .catch(error => {
          if (error.response.status === 422) {
            this.validation = error.response.data.validation
            this.$message({
              type: 'error',
              message: 'اطلاعات رو بررسی و دوباره تلاش کنید'
            })
          } else {
            this.$alert(error.response.data.message, 'خطا', {
              confirmButtonText: 'باشه'
            })
          }
        })
    }
  }
}
</script>
